Description

Related issues:

Related to Bugs - Bug #1706: temp-table buffer scoping New

History

#1 - 02/25/2013 08:53 AM - Constantin Asofiei

- Target version set to Milestone 4

Looks like 4GL allows a buffer reference in a procedure, without having its scope set, as it inherits the buffer scope from the caller.

def var ch as char

procedure proc0.

   message book.book-title. /* shows the first title */

end.

find first book.

run proc0.

 

In this case, field references need to trigger a buffer registration, but I think only if one is not explicitly set.

#2 - 02/25/2013 09:39 AM - Constantin Asofiei

This one is related to #1706. Looking at the perm buffer scoping from some compile listings from 4GL v9 and new ones generated on lindev01, there

are no differences related to buf scoping (just file format/date stamp diffs).

#3 - 02/25/2013 11:01 AM - Constantin Asofiei

- File field_in_proc_scope.p added

- File ca_upd20130225a.zip added

Fix attempt for scope computation for fields in procedures/functions without explicit buffer scope created by other statement.
https://proj.goldencode.com/issues/1706


#4 - 02/25/2013 11:40 AM - Greg Shah

I'm a little nervous about the change BUT I think it should be OK.  I'm going to put it into conversion testing now.

#5 - 02/25/2013 01:32 PM - Constantin Asofiei

- File ca_upd20130225b.zip added

I had a copy-paste error in SymbolResolver, I saved bufname instead of dbname in the "dbname" annotation. I'm running a conversion on my system

too, I'll let you know the results.

#6 - 02/25/2013 02:42 PM - Constantin Asofiei

The conversion has finished and the generated sources look good to me (only some reordering in openScope and buffer instance definition)

#7 - 02/25/2013 03:02 PM - Greg Shah

Check it in and distribute it.

#8 - 02/25/2013 03:15 PM - Constantin Asofiei

Committed to bzr revision 10204.

#9 - 02/25/2013 03:37 PM - Greg Shah

- Status changed from WIP to Closed

#10 - 02/26/2013 06:01 PM - Eric Faulhaber

- % Done changed from 0 to 100

#11 - 11/16/2016 11:07 AM - Greg Shah

- Target version changed from Milestone 4 to Conversion Support for Server Features

Files

ca_upd20130225a.zip 39.6 KB 02/25/2013 Constantin Asofiei

field_in_proc_scope.p 104 Bytes 02/25/2013 Constantin Asofiei

ca_upd20130225b.zip 39.9 KB 02/25/2013 Constantin Asofiei
